- name: Setup
  hosts: console
  tasks:
  - name: Copy check script
    copy:
      src: files/gitaly_check.rb
      dest: /tmp/gitaly_check.rb

- name: Rebuild and verify the packertest node
  hosts: packertest
  tasks:
  - name: Get current filesystem_uuid
    become: true
    command: gitlab-rails runner /tmp/gitaly_check.rb tcp://{{ inventory_hostname }}:9999
    delegate_to: "{{ groups['console'][0] }}"
    register: filesystem_uuid_before

  - name: Rebuild machine
    import_tasks: tf-apply.yml
    vars:
      plan_args: -replace="module.{{ module }}.{{ address }}" -target module.{{ module }}

  - name: Check /var/log in fstab
    command: grep '^UUID=.* /var/log ext4 discard,defaults 0 2$' /etc/fstab

  - name: Check /var/opt/gitlab in fstab
    command: grep '^UUID=.* /var/opt/gitlab ext4 discard,defaults 0 2$' /etc/fstab

  - name: Check the mounts are active
    command: df -h /var/opt/gitlab /var/log

  - name: Check omnibus version
    shell: dpkg -s gitlab-ee | grep Version
    register: actual_omnibus_version
    failed_when: omnibus_version not in actual_omnibus_version.stdout

  - name: Wait for bootstrap to complete, or for a restart to occur
    ansible.builtin.wait_for:
      path: /var/tmp/inital-boot-run.lock
    ignore_errors: true

  - name: Pause to wait for the restart
    pause:
      seconds: 5

  - name: Wait for machine to be available
    wait_for_connection:

  - name: Wait for bootstrap to complete
    ansible.builtin.wait_for:
      path: /var/tmp/inital-boot-run.lock

  - name: Run chef-client
    command: chef-client
    become: true

  - name: Check Ubuntu version
    command: lsb_release -r
    register: ubuntu_version
    failed_when: "ubuntu_version.stdout != 'Release:\t20.04'"

  - name: Check Linux kernel version
    command: uname -r
    register: linux_version
    failed_when: '"5.15.0" not in linux_version.stdout'

  - name: Get filesystem uuid
    command: jq -r .gitaly_filesystem_id /var/opt/gitlab/git-data/repositories/.gitaly-metadata
    become: true
    register: filesystem_uuid

  - name: Check filesystem_uuid
    become: true
    command: gitlab-rails runner /tmp/gitaly_check.rb tcp://{{ inventory_hostname }}:9999
    delegate_to: "{{ groups['console'][0] }}"
    register: filesystem_uuid_after
    failed_when: "filesystem_uuid_before.stdout != filesystem_uuid.stdout or filesystem_uuid_after.stdout != filesystem_uuid.stdout"
